theory StringReversal imports DpFramework
begin

definition is_srs :: "('f,'v)trs \<Rightarrow> bool"
where "is_srs R \<equiv> \<forall> f n. (f,n) \<in> funas R \<longrightarrow> n = 1"

fun reverse_term3 :: "'v \<Rightarrow> 'f list \<Rightarrow> ('f,'v)term"
where "reverse_term3 x (f # fs) = Fun f [reverse_term3 x fs]"
  | "reverse_term3 x [] = Var x"

fun reverse_term2 :: "'v \<Rightarrow> ('f,'w)term \<Rightarrow> 'f list \<Rightarrow> ('f,'v)term"
where 
    "reverse_term2 x (Fun f [t]) fs = reverse_term2 x t (f # fs)"
  | "reverse_term2 x (Var _) fs = reverse_term3 x fs"
  | "reverse_term2 x (Fun f []) fs = reverse_term3 x (f # fs)"

definition reverse_term :: "'v \<Rightarrow> ('f,'w)term \<Rightarrow> ('f,'v)term"
where "reverse_term x t = reverse_term2 x t []"

definition reverse_rule :: "'v \<Rightarrow> ('f,'w)rule \<Rightarrow> ('f,'v)rule"
where "reverse_rule x lr = (reverse_term x (fst lr), reverse_term x (snd lr))"

definition reverse_trs :: "'v \<Rightarrow> ('f,'w)trs \<Rightarrow> ('f,'v)trs"
where "reverse_trs x R = reverse_rule x ` R"

definition reverse_trsL :: "'v \<Rightarrow> ('f,'w)trsL \<Rightarrow> ('f,'v)trsL"
where "reverse_trsL x R = map (reverse_rule x) R"

definition is_csrs :: "('f,'v)trs \<Rightarrow> bool"
where "is_csrs R \<equiv> wf_trs R \<and> (\<forall> f n. (f,n) \<in> funas R \<longrightarrow> n \<le> 1)"



end

