{-# OPTIONS_GHC -fglasgow-exts #-}

module Matrix where {

import List;
import Nat;
import Util;
import Product_Type;

vec_zeroI :: forall a. a -> Nat -> [a];
vec_zeroI ze n = replicatea n ze;

mat0I :: forall a. a -> Nat -> Nat -> [[a]];
mat0I ze nr nc = replicatea nc (vec_zeroI ze nr);

vec1I :: forall a. a -> a -> Nat -> Nat -> [a];
vec1I ze on n i =
  append (replicatea i ze)
    (on : replicatea (minus_nat (minus_nat n one_nat) i) ze);

mat1I :: forall a. a -> a -> Nat -> [[a]];
mat1I ze on n = mapa (vec1I ze on n) (upt Zero_nat n);

vec_geI :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
vec_geI ge v w = foralla (\ (a @ (aa, b)) -> ge aa b) (zipa v w);

mat_geI :: forall a. (a -> a -> Bool) -> [[a]] -> [[a]] -> Bool;
mat_geI ge m1 m2 = foralla (\ (a @ (aa, b)) -> vec_geI ge aa b) (zipa m1 m2);

vec_pre_gtI :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
vec_pre_gtI gt v w = anya (\ (a @ (aa, b)) -> gt aa b) (zipa v w);

mat_pre_gtI :: forall a. (a -> a -> Bool) -> [[a]] -> [[a]] -> Bool;
mat_pre_gtI gt m1 m2 =
  anya (\ (a @ (aa, b)) -> vec_pre_gtI gt aa b) (zipa m1 m2);

mat_gtI ::
  forall a. (a -> a -> Bool) -> (a -> a -> Bool) -> [[a]] -> [[a]] -> Bool;
mat_gtI ge gt m1 m2 = mat_geI ge m1 m2 && mat_pre_gtI gt m1 m2;

wf_vecI :: forall x. Nat -> [x] -> Bool;
wf_vecI n x = size_list x == n;

transpose :: forall a. Nat -> [[a]] -> [[a]];
transpose nr [] = replicatea nr [];
transpose nr (v : m) =
  mapa (\ (a @ (aa, b)) -> aa : b) (zipa v (transpose nr m));

scalar_prodI ::
  forall a. a -> (a -> a -> a) -> (a -> a -> a) -> [a] -> [a] -> a;
scalar_prodI ze pl ti v w =
  foldra (\ xy -> pl (ti (fst xy) (snd xy))) (zipa v w) ze;

matT_vec_mulI ::
  forall a. a -> (a -> a -> a) -> (a -> a -> a) -> [[a]] -> [a] -> [a];
matT_vec_mulI ze pl ti m v = mapa (\ w -> scalar_prodI ze pl ti w v) m;

mat_mulI ::
  forall a.
    a -> (a -> a -> a) -> (a -> a -> a) -> Nat -> [[a]] -> [[a]] -> [[a]];
mat_mulI ze pl ti nr m1 m2 = mapa (matT_vec_mulI ze pl ti (transpose nr m1)) m2;

mat_arc_posI :: forall a. (a -> Bool) -> [[a]] -> Bool;
mat_arc_posI ap m = ap (nth (nth m Zero_nat) Zero_nat);

vec_max0I :: forall a. (a -> a) -> [a] -> [a];
vec_max0I a = mapa a;

mat_max0I :: forall a. (a -> a) -> [[a]] -> [[a]];
mat_max0I mz = mapa (vec_max0I mz);

vec_plusI :: forall a. (a -> a -> a) -> [a] -> [a] -> [a];
vec_plusI pl v w = mapa (\ xy -> pl (fst xy) (snd xy)) (zipa v w);

mat_plusI :: forall a. (a -> a -> a) -> [[a]] -> [[a]] -> [[a]];
mat_plusI pl m1 m2 = mapa (\ uv -> vec_plusI pl (fst uv) (snd uv)) (zipa m1 m2);

wf_mat_rcI :: forall a. Nat -> Nat -> [[a]] -> Bool;
wf_mat_rcI nr nc m = size_list m == nc && foralla (wf_vecI nr) m;

}
